# Sermon Notes

A program to take notes during a sermon.  The web app was built with PHP and Symfony.

## Installation

1. Run `docker run -d --name sermon-notes -p 80:80 ryanprather/sermon-notes:latest`, this will download and start the container and keep it running in the background.  If you already have something on port 80 change the first `80` to whatever open port you'd like.
2. Run `docker exec -it sermon-notes bash install.sh`  This will run an install script to create an .env file specific to your install, populate with the beginning factors, and then run a `composer` command to download the necessary package dependancies.
3. Once complete you have a running system that you can navigate to in your browser with `http://{ip}:{port}|{hostname}:{port}`.  Then you just need to register for an account.  The first account that is created is made an admin so that you can access the `Reference Editor` and update any reference material if necessary.

## Operation

This is the home page you're first presented with.

![Home](/assets/images/Home.png)

Create an account with "Register".

![Register](/assets/images/Registration.png)

Once you create an account you'll need to login

![Login](/assets/images/Login.png)

Once you get logged in you'll be presented with the main home page

![HomePage](/assets/images/HomePage.png)

If you are accessing on a regular iPad the menu should be collapsed, if not, you may need to do that.  I built this with a iPad 9th Gen in mind so visibility on another device may vary.

![Header](/assets/images/Header.png)

Across the top you will see a "plus" and "minus" buttons that will increase and decrease the size of font for the reference content.  The 3rd button is to open the Reference opener box.  On the right side you will see the "table" that will open the sermon details portion.  The next button is a preview button to preview the notes you have typed.  The final dropdown is to quickly apply a template for you to start taking notes.

![SermonData](/assets/images/SermonData.png)

These fields are meant to hide because you only need to fill them out once and they are the specifics of the sermon itself (e.g. title, date, speaker, series, and passage)

![Template](/assets/images/Template.png)

The notes you take are done in [Markdown](/docs/markdown-cheat-sheet.md).  In the above example, there is an introduction and 3 bullet points.  Each has a sub-bullet unordered list.  Review the Markdown link above for more tips on how to write Markdown.

When you are done with your Notes it will look something like the following.

![Example](/assets/images/MarkdownExample.png)

The tool is built that it will auto-save every 10 seconds and have a 5 second timeout should you be in a place where you don't have good internet service.  When the tool starts to save you will see an orange checkmark appear next to the "Notes" header above where your typing.  When it is done saving it will turn green and fade away.

I built this tool because I needed a way to take notes and have reference material open next to me.  So I built a reference opener to do just that

![ReferenceOpener](/assets/images/ReferenceOpener.png)

I have added many reference options (Bible, various creeds, Belgic Confession, Heidelberg Catechism, Canons of Dort, Westminster Confession of Faith, Westminster Larger Catechism, or Westminster Short Catechism).  I plan to add others in the future.  Simply select the type then filter to the book/chapter/week of the referenced work and hit "Search".  This will open the reference on the left side of the page.

![References](/assets/images/References.png)

You can switch between the references by clicking the button on the left side.  You can double-tap one of the buttons to remove that reference from the list.

Once a note has been saved, it can be retrieved in two different ways.  You can open the open page (by clicking on the Menu (hamburger) then "Open Notes")

![OpenNotes](/assets/images/OpenNotes.png)

or if the note was recently made you will see the most recent 4 notes listed under the menu

![RecentNotes](/assets/images/RecentNotes.png)

By clicking either of the title links it will open the note and display it for you to edit or read.  I can add "Notes" as future reference content.

